<%@ page language="java" %>
<%@ page import="java.text.*" %>
<%@ page import="java.util.Date" %>
<%@ page import="net.jx.sample.SampleBean" %>
<%@ page import="net.jx.servlet.ValidationException" %>
<%
    // Clear any old bean and create a new one in session keeping data from
    // parameters in the request.
    session.removeAttribute("sampleBean");
    SampleBean sampleBean = new SampleBean();
    session.setAttribute("sampleBean", sampleBean);

    // Get submitted fields
    String textField = request.getParameter("mandatoryTextField");
    String dateField = request.getParameter("dateField");
    String currencyField = request.getParameter("currencyField");

    // Instantiate the exception with the default message
    ValidationException validationEx =
        new ValidationException("Error validating submission", "/Form.jsp");

    // Mandatory text field validation.
    if (null == textField || textField.length() == 0)
        validationEx.addMessage("Mandatory field", "msgMandatoryField");
    else
        sampleBean.setMandatoryTextField(textField);

    // Date field validation.
    if (dateField != null && dateField.length() > 0) {
        String pattern = "MM-dd-yyyy";
        DateFormat dateFormatter = new SimpleDateFormat(pattern);
        try {
            Date date = dateFormatter.parse(dateField);
            sampleBean.setDateField(date);
        } catch (ParseException parseEx) {
            validationEx.addMessage("Wrong date: " + pattern, "msgDateField");
        }
    }

    // Floating point numeric field validation
    if (currencyField != null && currencyField.length() > 0) {
        try {
            double value = Double.parseDouble(currencyField);
            sampleBean.setCurrencyField(new Double(value));
        } catch (NumberFormatException nfEx) {
            validationEx.addMessage("Wrong numeric format", "msgCurrencyField");
        }
    }

    // if any submitted data has been rejected, bounce back...
    validationEx.raise();

    //make the bean persistent
    sampleBean.store();

    // the sampleBean is now persistent, we do not need it in session.
    session.removeAttribute("sampleBean");
    // go in the "success" page.
    response.sendRedirect(request.getContextPath() + "/Target.jsp");
%>